package org.ssssssss.magicboot.task;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.ssssssss.magicboot.controller.*;

@Configuration
@EnableScheduling
public class ZHYTask {
    @Autowired
    PreContractController preContractController;
    @Autowired
    FrameContractController frameContractController;
    @Autowired
    XSHTController xshtController;
    @Autowired
    DesignController designController;
    @Autowired
    GoodsPlanController goodsPlanController;
    @Autowired
    InvoiceController invoiceController;
    @Autowired
    QualityBackController qualityBackController;
    @Autowired
    TenderingController tenderingController;
    @Autowired
    BankInfoController bankInfoController;

    @Scheduled(cron = "0 0/1 * * * ?")
    private void configureTasks() throws Exception {
        System.out.println("开始同步数据");
        preContractController.syncContract();
        frameContractController.syncFrameContract();
        xshtController.syncXSHT();
        xshtController.isComplete();
        designController.syncDesign();
        goodsPlanController.syncGoodsPlan();
        invoiceController.syncInvoice();
        invoiceController.syncRedInvoice();
        qualityBackController.qualityFeedBack();
        tenderingController.syncTendering();
        bankInfoController.syncBankInfo();
        System.out.println("执行完毕");
    }
}
